module PointcutMatcher where

import Data.Char(isSpace)

-- | Takes an operation and a pointcut. Returns true if the
-- pointcut matches the operation.
matchPointcut :: String -> String -> Bool
matchPointcut _ "*"                 = True  -- an asterisk matches anything
matchPointcut [] []                 = True  -- empty strings match
matchPointcut [] (_:_)              = False -- non-empty pattern and empty declaration won't ever match and vice versa
matchPointcut (_:_) []              = False
matchPointcut (o:operation) (p:pattern)
  | p == o                          = matchPointcut operation pattern 
  | p == '*' && (not $ isSpace o)   = matchPointcut operation (p:pattern) 
  | p == '*' && isSpace o           = matchPointcut (o:operation) pattern
  | otherwise                       = False

