module AspectContextTest where

import Test.HUnit

import AspectContext
import Parser
import Result

tests = TestList [
  TestLabel "MatchAspectAdviceTest" testMatchAspectAdvice,
  TestLabel "PairAspectAdvicesTest" testPairAspectAdvices,
  TestLabel "BuildAspectContextTest" testBuildAspectContext,
  TestLabel "SearchAspectContextTest" testSearchAspectContext]

testMatchAspectAdvice = TestCase(do
  assertBool "testing aspect-advice matching" $ matchAspectAdvice (AspectSen "foo" 2 "") (AdviceSen "foo" ["x", "y"] "")
  assertBool "testing aspect-advice matching" $ not $ matchAspectAdvice (AspectSen "foo" 1 "") (AdviceSen "foo" ["x", "y"] "")
  assertBool "testing aspect-advice matching" $ not $ matchAspectAdvice (AspectSen "foo" 2 "") (AdviceSen "foobar" ["x", "y"] ""))

adviceSentences = [AdviceSen "foo" ["a"] "a = 3",
                   AdviceSen "bar" ["a", "b"] "a = b",
                   AdviceSen "bar" ["a", "b"] "a = a + b"]

testPairAspectAdvices = TestCase (do
  assertEqual "testing pairAspectAdvices" (Value (AspectSen "foo" 1 "pointcut", [AdviceSen "foo" ["a"] "a = 3"])) $ pairAspectAdvices adviceSentences (AspectSen "foo" 1 "pointcut")
  assertEqual "testing pairAspectAdvices" (Error "") $ pairAspectAdvices adviceSentences (AspectSen "foobar" 1 "pointcut"))

testBuildAspectContext = TestCase (
  assertEqual "testing buildAspectContext" (Value [(AspectSen "foo" 1 "oper _", [AdviceSen "foo" ["a"] "a = 3"])]) $ buildAspectContext [AspectSen "foo" 1 "oper _"] adviceSentences)

testSearchAspectContext = TestCase (
  assertEqual "testing searchAspectContext" [(AspectSen "foo" 1 "* _", [AdviceSen "foo" ["a"] "a = 3"])] $ searchAspectContext[(AspectSen "foo" 1 "* _", [AdviceSen "foo" ["a"] "a = 3"])] "oper _")