module CommandLineInterfaceTest where

import Test.HUnit

import CommandLineInterface
import Result

tests = TestList [
  TestLabel "CliTest" testCli]

testCli = TestCase (do
  assertEqual "testing CLI" (Value Settings {inputFile = "", outputFile = "a.maude", showHelp = True}) $ cli ["-h"]
  assertEqual "testing CLI" (Value Settings {inputFile = "input", outputFile = "a.maude", showHelp = False}) $ cli ["input"]
  assertEqual "testing CLI" (Value Settings {inputFile = "input", outputFile = "output", showHelp = False}) $ cli ["-o", "output", "input"]
  assertEqual "testing CLI" (Value Settings {inputFile = "", outputFile = "a.maude", showHelp = True}) $ cli ["-h", "input"]
  assertEqual "testing CLI" (Error "") $ cli ["input", "-h"]
  assertEqual "testing CLI" (Error "") $ cli ["-x"]
  assertEqual "testing CLI" (Error "") $ cli ["-x", "test"]
  assertEqual "testing CLI" (Error "") $ cli ["-o"]
  assertEqual "testing CLI" (Error "") $ cli ["-o", "-h"]
  assertEqual "testing CLI" (Error "") $ cli ["-o", "output"]
  assertEqual "testing CLI" (Error "") $ cli [])