module OperationContextTest where

import Test.HUnit

import Parser
import OperationContext
import Result

tests = TestList[
  TestLabel "BuildOperationContextTest" testBuildOperationContext,
  TestLabel "SearchOperationContextTest" testSearchOperationContext]

testBuildOperationContext = TestCase(do
  assertEqual "testing buildOperationContext" (Value ["foo _", "fee _", "_ bar _"]) $ buildOperationContext [AspectSen "as" 1 "f* _", AspectSen "as" 2 "_ bar _"] ["op foo _ : Nat -> Nat .", "op fee _ : Nat -> Nat .", "op _ bar _ : Nat Nat -> Nat]"]
  assertEqual "testing buildOperationContext" (Value []) $ buildOperationContext [AspectSen "as" 2 "_ f* _", AspectSen "as" 1 "bar _"] ["op foo _ : Nat -> Nat .", "op fee _ : Nat -> Nat .", "op _ bar _ : Nat Nat -> Nat]"])

testSearchOperationContext = TestCase(do
  assertEqual "testing searchOperationContext" (Just "_ foo _") $ searchOperationContext ["foo _", "_ bar _", "_ foo _"] "eq a foo b = a + b ."
  assertEqual "testing searchOperationContext" Nothing $ searchOperationContext ["foo _", "_ bar _", "_ _ foo _"] "eq a foo b = a + b .")