module PointcutMatcherTest where 

import Test.HUnit

import PointcutMatcher

tests = TestList [
  TestLabel "SimpleMatchTest" testSimpleMatch,
  TestLabel "AsteriskMatchTest" testAsteriskMatch]

testSimpleMatch = TestCase (do 
  assertBool "Testing a simple match" (matchPointcut "foo" "foo") 
  assertBool "Testing a simple match" (matchPointcut "foo _" "foo _") 
  assertBool "Testing a simple match" (matchPointcut "foo _ bar" "foo _ bar") 
  assertBool "Testing a simple match - false positive" (not $ matchPointcut "bar" "foo")
  assertBool "Testing a simple match - false positive" (not $ matchPointcut "foob" "foo") 
  assertBool "Testing a simple match - false positive" (not $ matchPointcut "foo" "foob") 
  assertBool "Testing a simple match - false positive" (not $ matchPointcut "foo _" "foo _ _") 
  assertBool "Testing a simple match - false positive" (not $ matchPointcut  "foo _ _" "foo _")) 
  

testAsteriskMatch = TestCase (do
  assertBool "Testing a simple asterisk match" (matchPointcut "foo" "foo*")
  assertBool "Testing a simple asterisk match" (matchPointcut "foobar" "foo*")
  assertBool "Testing an asterisk match with a space" (matchPointcut "foobar _" "foo* _")
  assertBool "Testing an asterisk match with many spaces" (matchPointcut "_ foobar _" "_ foo* _")
  assertBool "Testing an asterisk match with many spaces" (matchPointcut "_ foo _" "_ foo* _")
  assertBool "Testing an asterisk match - false positive" (not $ matchPointcut "foobar" "foo* bar")
  assertBool "Testing an asterisk match - false positive" (not $ matchPointcut "_ barfoo _" "_ foo* _")
  assertBool "Testing an asterisk match - false positive" (not $ matchPointcut "_ fobaro _" "_ foo* _"))
