module UtilsTest where

import Test.HUnit

import qualified Data.Char(isAlphaNum)
import Utils

tests = TestList [
  TestLabel "StripTest" testStrip,
  TestLabel "IsAlphaNumTest" testIsAlphaNum,
  TestLabel "SplitTest" testSplit]

testStrip = TestCase (do
  assertEqual "testing strip on string containing only spaces" "" $ strip "       "
  assertEqual "testing strip on empty string" "" $ strip ""
  assertEqual "testing strip" "a" $ strip " a ")

testIsAlphaNum = TestCase (do
  assertBool "testing alpha num" $ isAlphaNum "foobar"
  assertBool "testing alpha num" $ not $ isAlphaNum "foo_"
  assertBool "testing alpha num" $ not $ isAlphaNum "foo bar")

testSplit :: Test
testSplit = TestCase (do
  assertEqual "testing split" [[1, 2, 3], [4], [5, 6, 7], [8], [9, 10], [12]] $ split (\x -> x `mod` 4 == 0) [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12]
  assertEqual "testing split" [] $ split (\x -> x `mod` 4 == 0) []
  assertEqual "testing split" ["(", "pom", "+", "b", "-", "c",")"] $ split (not . Data.Char.isAlphaNum) "(pom+b-c)")

