module WeaverTest where

import Test.HUnit

import Result
import Weaver

input = "fmod TEST is\n\
         \op _ plus _ : Nat Nat -> Nat .\n\
         \op _ minus _ : Nat Nat -> Nat .\n\
         \vars a b : Nat .\n\
         \eq a plus b = a + b .\n\
         \eq a minus b = a - b .\n\
         \as aspectPlus _ _ : _ pl* _ .\n\
         \ad aspectPlus x y : y = 0 .\n\
         \ad aspectPlus x y : x = x + y .\n\
         \as aspectPlus2 _ _ : _ plus _ .\n\
         \ad aspectPlus2 x y : x = foo .\n\
         \endfm"

output = "fmod TEST is\n\
         \op _ plus _ : Nat Nat -> Nat .\n\
         \op _ minus _ : Nat Nat -> Nat .\n\
         \vars a b : Nat .\n\
         \eq a plus b = foo + b + 0 .\n\
         \eq a minus b = a - b .\n\
         \\n\
         \\n\
         \\n\
         \\n\
         \\n\
         \endfm"

tests = TestList [
  TestLabel "WeaveTest" testWeave]

testWeave = TestCase(
  assertEqual "testing weaving" (Value (lines output)) $ weave (lines input))